//
//  XMLRPCCallback.h
//  XMLRPC
//
//  Created by Russell Jancewicz on 2012-05-28.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
@class XMLRPCRequest;

typedef void (^XMLRPCSuccessBlock)(id object);
typedef void (^XMLRPCFailureBlock)(NSNumber *faultCode, NSString *faultString);

@protocol XMLRPCCallbackDelegate <NSObject>

@optional
@property (strong, nonatomic) id<XMLRPCCallbackDelegate> chain;

@required
- (void)request:(XMLRPCRequest *)request didSucceedWithObject:(id)object;
- (void)request:(XMLRPCRequest *)request didFailWithFaultCode:(NSNumber *)faultCode andFaultString:(NSString *)faultString;

@end


@interface XMLRPCBlockCallbacks : NSObject <XMLRPCCallbackDelegate>

@property (strong, nonatomic) XMLRPCSuccessBlock successCallback;
@property (strong, nonatomic) XMLRPCFailureBlock failureCallback;

+ (XMLRPCBlockCallbacks *)callbacksWithSuccessCallback:(XMLRPCSuccessBlock)success andFailureCallback:(XMLRPCFailureBlock)failure;
+ (XMLRPCBlockCallbacks *)callbacksWithSuccessCallback:(XMLRPCSuccessBlock)success;
+ (XMLRPCBlockCallbacks *)callbacksWithFailureCallback:(XMLRPCFailureBlock)failure;

@end

/*

@interface XMLRPCSelectorCallbacks : NSObject <XMLRPCCallbackDelegate>

@property (strong, nonatomic) NSObject *successTarget;
@property (strong, nonatomic) NSObject *failureTarget;
@property (readwrite, nonatomic) SEL successCallback;
@property (readwrite, nonatomic) SEL failureCallback;

@end

@interface XMLRPCInvocationCallbacks : NSObject <XMLRPCCallbackDelegate>

@property (strong, nonatomic) NSObject *successInvocation;
@property (strong, nonatomic) NSObject *failureInvocation;

@end
*/