//
//  XMLRPCEncoder.h
//  XMLRPC
//
//  Created by Russell Jancewicz on 2012-05-28.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class XMLRPCRequest;

@protocol XMLRPCEncoder <NSObject>

+ (id)encoder;
- (NSString *)encodeRequest:(XMLRPCRequest *)request;

@end

@interface XMLRPCEncoder : NSObject

+ (id)encoder;
- (NSString *)encodeRequest:(XMLRPCRequest *)request;
- (NSString *)encodeParameter:(id)paramter;
- (NSString *)encodeArray:(NSArray *)array;
- (NSString *)encodeDictionary:(NSDictionary *)dictionary;
- (NSString *)encodeNumber:(NSNumber *)number;
- (NSString *)encodeString:(NSString *)string;
- (NSString *)encodeDate:(NSDate *)date;
- (NSString *)encodeBoolean:(BOOL)boolean;

@end
