//
//  XMLRPCManager.m
//  XMLRPC
//
//  Created by Russell Jancewicz on 2012-05-27.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "XMLRPCManager.h"

@class XMLRPCRequest;

@implementation XMLRPCManager

@synthesize server = _server;
@synthesize requests = _requests;

+ (XMLRPCManager *)xmlrpcManagerWithServer:(NSURL *)server {
    
    XMLRPCManager *manager = [[XMLRPCManager alloc] init];
    
    manager.server = server;
    
    return manager;
}

- (void)shutdown {
    // TODO
}

- (void)requestMethod:(NSString *)method withParams:(NSArray *)params usingCallbacks:(id<XMLRPCCallbackDelegate>)callbacks {

    if (self.server) {
        
        XMLRPCRequest *request = [[XMLRPCRequest allocWithZone:NULL] init];
        
        request.method = method;
        request.params = params;
        request.server = self.server;
        request.callbacks = callbacks;
        
        [request sendAsynchronously];
    }
}


@end
