//
//  XMLRPCRequest.h
//  XMLRPC
//
//  Created by Russell Jancewicz on 2012-05-26.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "XMLRPCEncoder.h"
#import "XMLRPCManager.h"
#import "XMLRPCResponse.h"
#import "XMLRPCCallbacks.h"

@class XMLRPCRequest, XMLRPCResponse;

@protocol XMLRPCRequestDelegate <NSObject>

- (void)xmlrpcDidCompleteRequest:(XMLRPCRequest *)request withResponse:(XMLRPCResponse *)response;

@end


@interface XMLRPCRequest : NSObject

@property (strong, nonatomic) NSString *method;
@property (strong, nonatomic) NSArray *params;
@property (strong, nonatomic) NSURL *server; 

@property (strong, nonatomic) id<XMLRPCRequestDelegate> delegate;
@property (strong, nonatomic) id<XMLRPCCallbackDelegate> callbacks;
@property (strong, nonatomic) id<XMLRPCEncoder> encoder;

- (void)send;
- (void)sendAsynchronously;
- (void)sendSynchronously; 

@end
