//
//  XMLRPCResponse.m
//  XMLRPC
//
//  Created by Russell Jancewicz on 2012-05-28.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "XMLRPCResponse.h"
#import "XMLRPCRequest.h"
#import "XMLRPCDecoder.h"

@interface XMLRPCResponse ()

@property (strong, nonatomic) XMLRPCDecoder *decoder; 
// add parser mode.

@end


@implementation XMLRPCResponse

@synthesize fault = _fault;
@synthesize faultCode = _faultCode;
@synthesize faultString = _faultString;
@synthesize object = _object;

@synthesize request = _request; // request 

@synthesize decoder;

- (id)initWithData:(NSData *)data forRequest:(XMLRPCRequest *)request {

    self = [super init];
    if (self) {
        _request = request;
        
        self.decoder = [[XMLRPCDecoder allocWithZone:NULL] initWithData:data];
        
        _object = [self.decoder decode];
        _fault = self.decoder.fault;
        
        if (self.fault) {
            _faultCode = [self.object objectForKey:@"faultCode"];
            _faultString = [self.object objectForKey:@"faultString"];
        }
        
        
    }
    return self;
}

+ (XMLRPCResponse *)responseWithData:(NSData *)data forRequest:(XMLRPCRequest *)request{
    return [[XMLRPCResponse allocWithZone:NULL] initWithData:data forRequest:request];
}

- (void)performCallbacks {
    
    if (self.request.callbacks != nil) {
        
        if (self.fault) {
            [self.request.callbacks request:self.request didFailWithFaultCode:self.faultCode andFaultString:self.faultString];
        } else {
            [self.request.callbacks request:self.request didSucceedWithObject:self.object];
        }
        
    }
}


@end
